module TokenServer
    class Account
        include ActiveModel::Model

        attr_accessor :url_name

        # Select different account models if necessary regarding to the sub-domain
        # (not used yet)
        def self.find_by(url_name: nil)
            Account.new
        end

        # Find user and check password. Send optional metainformations for login.
        # Return a user object that contains the right information.
        # Params:
        #     user: The user name of the requesting user.
        # password: The password for authentication against the service layer
        #     meta: A hash that contains additionals params taken from the request header. See *TokenServer::header_param_keys* for details
        def authenticate(user, password, meta = {})

            # TODO: Fill me
            ::TokenServer::User.new(user_id: user, password: password, is_plugin_manager: true, credentials_hash: {})
        end
    end
end
